The Halloween Documents: Microsoft's Anti-Linux Strategy 15 Years Later
================================================================================
> It's been 15 years since leaked memos revealed Microsoft's anti-Linux and open source strategy. Here's how it failed.

![](http://thevarguy.com/site-files/thevarguy.com/files/imagecache/medium_img/uploads/2013/10/trickortreat2.jpg)

It's almost Halloween—which marks 15 years since Eric S. Raymond published the first leaked "[Halloween Documents][1]" documenting Microsoft's (MSFT) secret strategy to compete with Linux and open source. A lot has changed since then, when terms such as "fear, uncertainty and doubt" (FUD) first exploded into the lexicon. But how much remains the same? Do Microsoft and open source play nicely today?

The Halloween Documents, so-called because the first one leaked in October 1998, don't actually have much to do with Halloween itself—which I find sad, as an avid fan of the holiday. But for understanding the historical relationship between Microsoft and open source, the memos are vital.

They were the first to reveal the particularly nasty "tricks" Microsoft planned in its effort to contain the open source movement, and to prevent Linux in particular from cutting too deeply into its revenue. One key strategy for the company was implementing proprietary protocols to lock customers into Microsoft software. Another was touting Microsoft software as offering lower total cost of ownership (TCO) than Linux, even though the documents showed that Microsoft itself found Linux to be the cheaper overall solution in many cases.

History, however, has proven Microsoft's strategy largely wrong. Fifteen years after Raymond published the first of the documents (he subsequently added several more to his site, along with extensive commentary), which Microsoft later acknowleded to be authentic, Windows and Linux continue to coexist. And while Linux and open source never became an existential threat to Microsoft, as the Halloween Documents suggest executives at the company once feared, it's hard to deny that they have significantly curtailed the company's share of important markets, like servers operating systems and applications, for many years. Microsoft might be a richer enterprise today if it had achieved the goals it articulated in the Halloween Documents.

And the story's not over. Today, the flashpoints between Microsoft and open source have shifted in many ways, and Redmond has few reasons to worry about Linux replacing its flagship software for desktop computers. But in the mobile world, Linux-based Android, alongside iOS, constitutes a major challenge for Microsoft's vision of dominating tablets and smartphones. The cloud and Big Data, too, are increasingly the domain of open source software, with solutions including Hadoop and OpenStack facing few real challenges from Microsoft or any other proprietary competitor. In different ways but for the same essential reasons, the open source ecosystem remains a thorn in Microsoft's side.

Of course, Microsoft today is no longer the company it was in 1998. The era of its unbridled expansion ended long ago, and it's hard to imagine any disruption big enough to pose a serious challenge to its dominance within the huge market for desktop operating systems and office software. If the company ever does face decline, it is much likelier to be the result not of Linux but of a structural shift away from traditional computing altogether—and such a change will not come anytime soon.

For today, though, the Halloween Documents are worth revisiting as a reminder of how not to respond to competition from open source code. In the long run, companies that have embraced open source technologies and developed business models that thrive on the sharing of software, such as Red Hat (RHT), will do better than those that attempt to protect their interests through FUD and vendor lock-in. Red Hat today has much smoother and potentially more lucrative options for continued growth in the areas of open source dominance mentioned above—such as the cloud and Big Data—than Microsoft or even Apple, which face expensive and riskier investment in new types of hardware if they hope to expand their business.

The lesson: Sharing—whether of candy or software—is the way to go. Happy Halloween!

--------------------------------------------------------------------------------

via: http://thevarguy.com/open-source-application-software-companies/halloween-documents-microsofts-anti-linux-strategy-15-yea

译者：[译者ID](https://github.com/译者ID) 校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:http://www.catb.org/~esr/halloween/